## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%{!?_pkgdocdir: %global _pkgdocdir %{_docdir}/%{name}-%{version}}

%global forgeurl https://github.com/dmtcp/dmtcp
Version:        3.0.0
%global tag %{version}
%forgemeta

Name:           dmtcp
Release:        %autorelease
Summary:        Distributed MultiThreaded CheckPointing

# DMTCP is mainly under LGPL-3.0-or-later, except:
# The file include/dmtcp.h is released under MIT/BSD dual license. The user is
# allowed to use these files under either license.
# https://github.com/dmtcp/dmtcp/blob/master/COPYING
License:        LGPL-3.0-or-later AND (MIT OR BSD-3-Clause)
URL:            http://dmtcp.sourceforge.net
Source0:        %{forgesource}

BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  python3

# This package is functional only on i386, x86_64 and aarch64 architectures.
# It should also work on %%ix86, but Koji seems to have problems with it.
## We're excluding aarch64 for now, because we don't have a trampoline for it.
## In the next relase, we won't need the trampoline.  We'll interpose
##   entirely on pthread_create, and not on __clone3
## ExclusiveArch: x86_64 aarch64
ExclusiveArch: x86_64

%description
DMTCP is a tool to transparently checkpoint the state of multiple simultaneous
applications, including multi-threaded and distributed applications. It operates
directly on the user binary executable, without any Linux kernel modules or
other kernel modifications.

Among the applications supported by DMTCP are MPI (various implementations),
OpenMP, MATLAB, Python, Perl, R, and many programming languages and shell
scripting languages. DMTCP also supports GNU screen sessions, including
vim/cscope and emacs. With the use of TightVNC, it can also checkpoint and
restart X Window applications. For a multilib (mixture of 32- and 64-bit
processes), see "./configure --enable-multilib".

DMTCP supports the commonly used OFED API for InfiniBand, as well as its
integration with various implementations of MPI, and resource managers (e.g.,
SLURM).

This package contains DMTCP binaries.

%package        devel
Summary:        DMTCP developer package
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
This package provides files for developing DMTCP plugins.

%prep
%forgeautosetup -p1

%build
%configure --docdir=%{_pkgdocdir}
%make_build

%install
%make_install

# A few tests may take a long time.  If a test times out, the check fails.
# Hopefully, the test machine is fast enough, and timeouts are long
#   enough to avoid that problem.
# 2022-09 - Disabled tests to fix FTBFS on Fedora 36+
# %check
# AUTOTEST="--retry-once --slow" make check

%files
%license COPYING.LESSER
%{_bindir}/dmtcp_*
%{_bindir}/mtcp_restart
%{_libdir}/%{name}
%{_pkgdocdir}/
%{_mandir}/man1/*.1*

%files devel
%{_includedir}/dmtcp.h
%{_includedir}/version.h

%changelog
## START: Generated by rpmautospec
* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.1~rc2-0.6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.1~rc2-0.5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Sep 09 2022 Filipe Rosset <rosset.filipe@gmail.com> - 2.6.1~rc2-0.4
- Disabled tests to fix FTBFS on Fedora 36+

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.1~rc2-0.3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.1~rc2-0.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Dec 17 2019 Gene Cooperman <gene@ccs.neu.edu> - 2.6.1~rc1-0.1
- Preparing for upstream release 2.3.

* Thu Jul 3 2014 Kapil Arya <kapil@ccs.neu.edu> - 2.3-1
- Preparing for upstream release 2.3.

* Mon Mar 10 2014 Kapil Arya <kapil@ccs.neu.edu> - 2.2-1
- Preparing for upstream release 2.2.
- Remove libmtcp* packages.
- Install all docs in _pkgdocdir
- Added --retry-once flag to autotest.

* Fri Jan 10 2014 Kapil Arya <kapil@ccs.neu.edu> - 2.1-1
- Preparing for upstream release 2.1.

* Thu Dec 12 2013 Ville Skytta <ville.skytta@iki.fi> - 1.2.8-2
- Install docs to %%{_pkgdocdir} where available (#993726).
- Own package level doc dir.

* Tue Jul 30 2013 Kapil Arya <kapil@ccs.neu.edu> - 1.2.8-1
- Preparing for upstream release 1.2.8.

* Mon Mar 11 2013 Kapil Arya <kapil@ccs.neu.edu> - 1.2.7-1
- Preparing for upstream release 1.2.7.
- Use %%{_docdir} instead of %%doc for QUICK-START and COPYING.

* Tue Oct 09 2012 Orion Poplawski <orion@cora.nwra.com> - 1.2.6-1
- Update to 1.2.6
- Use URL for Source0
- Add patch to drop -fstack-protector on mtcp_maybebpt.c
- Drop configure hack
- Run tests

* Sun Jul 08 2012 kapil@ccs.neu.edu
- Preparing for upstream release 1.2.5.

* Tue Jan 24 2012 kapil@ccs.neu.edu
- Preparing for upstream release 1.2.4.

* Mon Jan 23 2012 kapil@ccs.neu.edu
- Updating to svn 1449.

* Tue Oct 25 2011 kapil@ccs.neu.edu
- Updating to svn 1321.
- libdmtcpaware-devel-static renamed to libdmtcpaware-static
- %%{_isa} added to Requires
- disable_option_checking changed from "fatal" to "no"
- QUICK_START and COPYING installed using %%{doc}

* Tue Aug  9 2011 gene@ccs.neu.edu
- Updating to upstream release 1.2.3-1.svn1247M.
- svn revision 1246 adds objcopy to set section attribute in libmtcp.so
  (if debuginfo repo was present during build, limbtcp.so was missing a section)
- dmtcp.spec and 'make install' changed for improved file layout

* Tue Jul 26 2011 kapil@ccs.neu.edu
- Top level configure files updated to fix configure error.

* Fri Jul 22 2011 kapil@ccs.neu.edu
- Updating to upstream release 1.2.3.

* Sat Jul  2 2011 kapil@ccs.neu.edu
- Updating to upstream release 1.2.2.

* Wed Jun 22 2011 kapil@ccs.neu.edu
- Exclude mtcp.c from installation.

* Wed Jun 22 2011 kapil@ccs.neu.edu
- Updating to upstream release 1.2.2.

* Fri Jun 17 2011 kapil@ccs.neu.edu
- libdmtcpaware.a moved to libdmtcpaware-devel-static package.
- dmtcpaware examples moved to libdmtcpaware-doc package.

* Fri Jun 10 2011 kapil@ccs.neu.edu
- Build requirements updated.
- Minor cleanup.

* Tue Jun  7 2011 kapil@ccs.neu.edu
- Added "ExclusiveArch %%ix86 x86_64" and removed ExcludeArch lines.
- buildroot not cleaned in %%install section.

* Sat May 14 2011 kapil@ccs.neu.edu
- dependency on libc.a removed for mtcp_restart.
- Several other bug fixes and improvements.

* Sat Mar 12 2011 kapil@ccs.neu.edu
- Updated to release 1.2.1

* Fri Mar 11 2011 kapil@ccs.neu.edu
- Remove debug flags.

* Fri Mar 11 2011 kapil@ccs.neu.edu
- Updated to revision 935.

* Thu Mar 10 2011 kapil@ccs.neu.edu
- Reverting tarball to prev version.

* Thu Mar 10 2011 kapil@ccs.neu.edu
- Testing fix for restart under 32-bit OSes.

* Thu Mar 10 2011 kapil@ccs.neu.edu
- Updated tarball with compiler warnings fixed.

* Thu Mar 10 2011 kapil@ccs.neu.edu
- Added python to dependency list for running make check.

* Thu Mar 10 2011 kapil@ccs.neu.edu
- Preparing for release 1.2.1. Pulled updates from the latest dmtcp svn.

## END: Generated by rpmautospec
